• Making the Grade


    问题 F: Making the Grade

    时间限制: 1 Sec  内存限制: 128 MB
    提交: 4  解决: 2
    [提交] [状态] [讨论版] [命题人:admin]

    题目描述

    A straight dirt road connects two fields on FJ's farm, but it changes elevation more than FJ would like. His cows do not mind climbing up or down a single slope, but they are not fond of an alternating succession of hills and valleys. FJ would like to add and remove dirt from the road so that it becomes one monotonic slope (either sloping up or down).

    You are given N integers A1, ... , AN (1 ≤ N ≤ 2,000) describing the elevation (0 ≤ Ai ≤ 1,000,000,000) at each of N equally-spaced positions along the road, starting at the first field and ending at the other. FJ would like to adjust these elevations to a new sequence B1, . ... , BN that is either nonincreasing or nondecreasing. Since it costs the same amount of money to add or remove dirt at any position along the road, the total cost of modifying the road is

    |A1 - B1| + |A2 - B2| + ... + |AN - BN |
    Please compute the minimum cost of grading his road so it becomes a continuous slope. FJ happily informs you that signed 32-bit integers can certainly be used to compute the answer.

    输入

    * Line 1: A single integer: N
    * Lines 2..N+1: Line i+1 contains a single integer elevation: Ai

    输出

    * Line 1: A single integer that is the minimum cost for FJ to grade his dirt road so it becomes nonincreasing or nondecreasing in elevation.

    样例输入

    7
    1
    3
    2
    4
    5
    3
    9

    样例输出

    3

      

    题意 :

    给定 n 个数,要求构造一个新的序列非严格单调序列,使得代价最小。 代价计算方法为:sum { | ai-bi | }  (  1<= i <=n ) 。 


    思路: 

    dp状态定义 
    
    dp(i,j) 表示 第 i 个数为 j 时的最小代价。
    
    状态转移方程:
    
    dp(i,j) = abs(a[i]-j) + dp(i,k)。(1<=k<=j)
    
    这个状态转移方程是 O(n3) 的复杂度。
    
    通过学习大佬们的博客,学习了通过离散化将复杂度降为O(n2)的做法。
    即:
    
    dp(i,j) 表示第 i 个数为原数组中第 j 小的数。
    
    a 排序后为数组 b。
    
    当 dp过程进行到 dp(i,j)时,最小代价为 abs(ai-bj) + min。( min代表 第 i-1 个数为 1~j时的最小费用)。
    min 可以在枚举 j 时同时求出,因此可将复杂度降为O(n2)。

    代码如下:

     1 #include <bits/stdc++.h>
     2 
     3 using namespace std;
     4 const int maxn=2010;
     5 typedef long long ll;
     6 int n,a[maxn],b[maxn];
     7 ll dp[maxn][maxn];
     8 
     9 int main(){
    10     scanf("%d",&n);
    11     for (int i=1; i<=n; i++){
    12         scanf("%d",&a[i]);
    13         b[i] = a[i];
    14     }
    15 
    16     sort(b+1,b+1+n);
    17 
    18     for (int i=1; i<=n; i++){
    19         ll mi=dp[i-1][1];
    20         for (int j=1; j<=n; j++){
    21             mi=min(mi,dp[i-1][j]);
    22             dp[i][j] = abs(a[i]-b[j]) + mi;
    23         }
    24     }
    25 
    26     ll ans=(1ll<<63)-1;
    27     for (int i=1; i<=n; i++)
    28         ans=min(ans,dp[n][i]);
    29     printf("%d
    ",ans);
    30 
    31     return 0;
    32 }
  • 相关阅读:
    hdu 3996
    poj 3189
    poj 2391
    zoj 3165
    【Visual Studio】
    httpwebrequest Winform 上传图片
    [MVC] win7 下 配置 IIS 问题
    win7 下 升级 vs2008
    [Visual Studio 2010] NET 4.0 WinForm无法引用System.Web.dll的解决方法
    [XML] XML
  • 原文地址:https://www.cnblogs.com/acerkoo/p/9508465.html
Copyright © 2020-2023  润新知